controllers/ArticuloController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Articulo;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * ArticuloController implements the CRUD actions for Articulo model.
 */
class ArticuloController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Articulo models.
     * @return mixed
     */
    public function actionIndex() {
        $dataProvider = new ActiveDataProvider([
            'query' => Articulo::find(),
            'pagination'=>[
                'pageSize'=>'2',
            ]
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionListar() {
<<<<<<< HEAD
        $dataProvider = new ActiveDataProvider([
=======
        $$dataProvider = new ActiveDataProvider([
>>>>>>> bb40fc67a67275b49dc89ded30faa53065516d20
            'query' => Articulo::find(),
            'pagination'=>[
                'pageSize'=>'2',
            ]
        ]);

        return $this->render('listar', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Articulo model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Articulo model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Articulo();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Articulo model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Articulo model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Articulo model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Articulo the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Articulo::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/FotosController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Fotos;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * FotosController implements the CRUD actions for Fotos model.
 */
class FotosController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Fotos models.
     * @return mixed
     */
    public function actionIndex() {
        $dataProvider = new ActiveDataProvider([
            'query' => Fotos::find(),
            'pagination'=>[
                'pageSize'=>'2',
            ]
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionListar() {
        $listar = Fotos::find()->all();
        
        return $this->render('listar', [
            'datos' => $listar,
        ]);
    }

    /**
     * Displays a single Fotos model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Fotos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Fotos();
        
        /*$model->articulo="1"; // Con estas 5 líneas. Así se haría a mano, sin la ayuda del model y action
        $model->nombre="1.jpg";
        $model->alt="Ejemplo de foto en el artículo";
        //$model->validate(); // Sirve para comprobar si es true o false y saber si puede grabar el dato
        $model->save();    // Con estas 3 instrucciones se podría grabar un dato
        exit;   // Paro las acciones para seguir con el if*/

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Fotos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        
//        $model = new Fotos(); // Con estas 5 líneas. Así se haría a mano, sin la ayuda del model y action
//        
//        $model->id=2;
//        $model->articulo="2";
//        $model->nombre="2.jpg";
//        $model->alt="Foto del artículo 2"; // Así se haría a mano, sin la ayuda del model y action
        
//        Fotos::find()->where('id'=>$id)->one();   // Todo esto es el findModel
//        Fotos::findOne($id); // Es mejor que lo de arriba

//        if ($model->load(Yii::$app->request->post()) && $model->save()) {
//            return $this->redirect(['view', 'id' => $model->id]);
//        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Fotos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Fotos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Fotos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Fotos::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\web\Controller;
use yii\web\Response;
use app\models\Articulo;
use app\models\Fotos;



class SiteController extends Controller {
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
        ];
    }

    public function actionIndex() {
        $datos = Articulo::find()->all();   // Array de objetos
        
        return $this->render('index', [
            "articulos" => $datos,  //  $datos es toda la información de la la tabla de la base de datos desde el controller y "articulos" son los datos que se pasan a las views
        ]);
    }
    
    public function actionBack() {
        
        return $this->render('back');
        
//        $datos = Articulo::find()->all();   // Array de objetos
        
//        return $this->render('back', [
//            "articulos" => $datos,  //  $datos es toda la información de la la tabla de la base de datos desde el controller y "articulos" son los datos que se pasan a las views
//        ]);
    }

}

views/site/back.php
<?php

    use yii\helpers\Html;
    use yii\bootstrap\Nav;
    
    $this->params['breadcrumbs'][] = $this->title = 'Back';

?>

    <ul class="nav nav-pills nav-stacked">
        <li role="presentation">
            <?= Html::a('Artículos', ['articulo/index'], ["class" => "btn bg-info"]) ?>
        </li>
      <li role="presentation">
          <?= Html::a('Fotos', ['fotos/index'], ["class" => "btn bg-info"]) ?>
      </li>
    </ul>


<br>
<div class="index">
<!--< ?=
        Nav::widget([
        'options' => ['class' => 'nav nav-pills nav-stacked'],		// ES LO MISMO QUE ARRIBA PERO UTILIZANDO Nav::widget
        'items' => [
            ['label' => 'Artículos', 'url' => ['articulo/index']],
            ['label' => 'Fotos', 'url' => ['fotos/index']],
        ],
    ]);
        
? >-->

</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

use app\models\Fotos;

/* @var $this yii\web\View */

$this->title = 'Aplicación Básica 4 Yii 2';

//var_dump($articulos);

?>
<div class="site-index">
    <ul>
        <?php
        
        foreach ($articulos as $articulo) {
            echo $this->render('index/_articulo', [
                "datos" => $articulo,
            ]);
        
        
        // VER LAS FOTOS DEL ARTÍCULO ACTUAL
        
        $fotosArticulo = $articulo->fotos;  // Array del modelo fotos
        foreach ($fotosArticulo as $foto) {
        
            echo $this->render('index/_fotos', [
                "datos" => $foto,
            ]);
            
//            Fotos::find()->all; // Todas las fotos
            
//            $a = $articulo->fotos; // Es lo mismo que lo de abajo y es MEJOR
//            var_dump($a);
//            
//            $a = Fotos::find()
//                    ->where(["articulo"=>$articulo->id])
//                    ->all();
//            var_dump($a);
        }
        }
        ?>
    </ul>
</div>